(function(){
if(!window.ScoreViewerIIDX24){
	ScoreViewerIIDX24_setup();
}
var app = ScoreViewerIIDX24;

app.userDataDefault = function (){
	var obj = {};

	obj.name = "NODATA";
	obj.playcount = {};
	obj.clear = {};
	obj.djlv = {};
	obj.next = {};
	obj.score = {};
	obj.pgreat = {};
	obj.great = {};
	obj.miss = {};
	obj.disabled = true;
	obj.category = -1;
	obj.topname = {};
	obj.version = -1;

	obj.id = "NODATA";
	obj.time = {};
	obj.time.main = "";

//	obj.pref = '';
//	obj.shop = '';

	return obj;
};

app.sortMusic = function (){
	for(var i=0; i<app.music_id.length; i++){
		for(var j=app.music_id.length-1; j>i; j--){
			var str1 = app.strFullToHalf(app.music_list.music_list[app.music_id[j-1]].name.toUpperCase());
			var str2 = app.strFullToHalf(app.music_list.music_list[app.music_id[j]].name.toUpperCase());
			if(str1 > str2){
				var tmp = app.music_id[j-1];
				app.music_id[j-1] = app.music_id[j];
				app.music_id[j] = tmp;
			}
		}
	}
	return;
};

app.scoreViewerSetup = function (){
	app.style_name = new Array("SINGLE", "SINGLE", "SINGLE", "DOUBLE", "DOUBLE", "DOUBLE");
	app.style_name[-1] = "SINGLE";
	app.style_name2 = new Array("SP", "SP", "SP", "DP", "DP", "DP");
	app.style_name2[-1] = "SP";
	app.diff_name = new Array("NORMAL", "HYPER", "ANOTHER", "NORMAL", "HYPER", "ANOTHER");
	app.diff_name[-1] = "BEGINNER";
	app.diff_name2 = new Array("SPN", "SPH", "SPA", "DPN", "DPH", "DPA");
	app.diff_name2[-1] = "SPB";
	app.diff_color = new Array("#50FFFF", "#FFFF50", "#FF5050", "#50FFFF", "#FFFF50", "#FF5050");
	app.diff_color[-1] = "#50FF50";
	app.num_rival_view = 0;

//	app.music_list = {};//{version->i->{version, name}}, {music_list->mid->{version, mid, name, diff[0-5]}}
//	app.music_id = {};//app.music_id[通し番号] = mid
	app.music_id = [];
	for(var i in app.music_list.music_list){
		app.music_id.push(app.music_list.music_list[i].mid);
	}
	app.sortMusic();

//	app.view_data = {};
	app.user_data = [];
//	for(var i=0; i<=20; i++){
//		app.userDataDefault(i);
//	}

	app.view_list = [];

	app.rival_data = [];
	app.rival_top_data = [];
	app.unofficial_diff = {};
	app.unofficial_diff.time = "none";

	app.readTask = {
		wait: [],
		comp: [],
		fail: []
	};

	app.timeout = app.sv_Branch.getIntPref("timeout") * 1000;

	app.mainTab = gBrowser.getBrowserForTab(gBrowser.selectedTab = gBrowser.addTab("chrome://ScoreViewerForIIDX24/content/main.html"));
	app.mainTab.addEventListener("load", function(){
		app.mainTab.removeEventListener("load", arguments.callee, true);
		//ページ破棄時
		app.mainTab.addEventListener("beforeunload", function(){
			app.mainTab.removeEventListener("beforeunload", arguments.callee, true);
			//ソート情報保存
			if(app.sv_Branch.getBoolPref("save_sort")){
				app.sv_Branch.setIntPref("sort1_diff", app.mainTab.contentDocument.getElementById('sort1_diff').value);
				app.sv_Branch.setIntPref("sort1_cat", app.mainTab.contentDocument.getElementById('sort1_cat').value);
				app.sv_Branch.setIntPref("sort1_order", app.mainTab.contentDocument.getElementById('sort1_order').value);
				app.sv_Branch.setIntPref("sort2_diff", app.mainTab.contentDocument.getElementById('sort2_diff').value);
				app.sv_Branch.setIntPref("sort2_cat", app.mainTab.contentDocument.getElementById('sort2_cat').value);
				app.sv_Branch.setIntPref("sort2_order", app.mainTab.contentDocument.getElementById('sort2_order').value);
			}
		}, true);
		//ソート情報読み込み
		if(app.sv_Branch.getBoolPref("save_sort")){
			var tmp_array = new Array(
				"sort1_diff",
				"sort1_cat",
				"sort1_order",
				"sort2_diff",
				"sort2_cat",
				"sort2_order"
			);
			for(var i=0; i<tmp_array.length; i++){
				var tmp_select = app.mainTab.contentDocument.getElementById(tmp_array[i]);
				var tmp_int = app.sv_Branch.getIntPref(tmp_array[i]);
				for(var j=0; j<tmp_select.length; j++){
					if(tmp_int == tmp_select.options[j].value){
						tmp_select.selectedIndex = j;
						tmp_select.value = tmp_int;
						break;
					}
				}
			}
		}
		app.mainTab.contentDocument.title = app.title_default;
		app.readVersionInfo();
		app.readInfo();
		app.setupWindow();
		app.writeCategory();
		app.categoryDisable();
		if(app.sv_Branch.getBoolPref("autoload")){
			try{
				var tmp = app.getData();
				if(tmp === 0){
					app.mainTab.contentDocument.getElementById("time_unofficial_diff").innerHTML = app.unofficial_diff.time;
				}
			}catch(e){
				alert("データが読み込めません。\n" + e);
			}
		}
		app.buttonEnable();
		app.rivalDefault();
		app.rivalViewCheck();
	}, true);

	return;
};

app.readInfo = function (){
	if(app.sv_Branch.getBoolPref("info_check")){
		var req = new XMLHttpRequest();
		req.open('GET', app.URL_info + '?random=' + Math.random(), true);
		req.onreadystatechange = function (aEvt) {
			if(req.readyState == 4) {
				if(req.status == 200){
					app.mainTab.contentDocument.getElementById("info").innerHTML = req.responseText;
				}
			}
		};
		req.send(null);
	}

	return;
};

app.readVersionInfo = function (){
	if(app.sv_Branch.getBoolPref("vinfo_check")){
		var req1 = new XMLHttpRequest();
		req1.open('GET', app.URL_vdata + '?random=' + Math.random(), true);
		req1.onreadystatechange = function (aEvt) {
			if(req1.readyState == 4) {
				if(req1.status == 200){
					if(app.scoreviewer_version != req1.responseText){
						var req2 = new XMLHttpRequest();
						req2.open('GET', app.URL_vinfo + '?random=' + Math.random(), true);
						req2.onreadystatechange = function (aEvt) {
							if(req2.readyState == 4) {
								if(req2.status == 200){
									app.mainTab.contentDocument.getElementById("vinfo").innerHTML = req2.responseText;
								}
							}
						};
						req2.send(null);
					}
				}
			}
		};
		req1.send(null);
	}

	return;
};

})();
